\ slice.fs

23 CONSTANT slices
0 VALUE limit

CREATE data
slices cells allot

: erase-data ( -- )   data slices cells erase ;

: count-data ( n -- )
    slices limit ( 1+ ) */
    0 max
    [ slices 1- ] literal min
    cells data +   1 swap +! ;

\ : show-range ( i -- )
\     dup limit slices */ >r ." 	" r@ .
\     1+ limit slices */ ." 	" dup .
\     ." 	" r> - . ;

\ : show-range ( i -- )
\     dup slices swap - limit slices */  limit swap - >r
\     ." 	" r@ .
\     1+  slices swap - limit slices */  limit swap -
\     ." 	" dup .
\     ." 	" r> - . ;

: slice-border ( i -- n )   >r limit  slices r> - limit slices */  - ;

: show-range ( i -- )
    dup slice-border ." 	" dup .
    swap slice-border ." 	" dup .
    ." 	" swap - . ;

: show-range ( i -- )
    >r
    limit  slices r@ - limit slices */  -
    ." 	" dup .
    limit  slices r> 1+ - limit slices */  -
    ." 	" dup .
    ." 	" swap - . ;

: show-counts ( -- )
    page
    slices 1+ 0 DO
	cr i . ." 	" data i cells + @ .
	i show-range
    LOOP
    cr ;

\ : count-data-2 ( n -- )
\     slices 1- limit ( 1+ ) */
\     0 max
\     [ slices 1- ] literal min
\     cells data +   1 swap +! ;

: test ( n -- )
    erase-data
    dup to limit
    0 DO
	i count-data
    LOOP
    show-counts
    key drop ;

23 test

\ bye
