\ debuging.fs
\ 	$Id: debuging.fs,v 1.14 2009-10-24 04:14:59 f Exp $	
\ help debugging ;-)

\ VARIABLE (dada)		(dada) off	\ private debug scratch var
VARIABLE DADA-do-1-xt	' noop DADA-do-1-xt !	\ private debug scratch hook
VARIABLE DADA-do-2-xt	' noop DADA-do-2-xt !	\ private debug scratch hook
VARIABLE DADA-do-3-xt	' noop DADA-do-3-xt !	\ private debug scratch hook
DEFER .world:step:spot	' noop IS .world:step:spot

2VARIABLE DADA-str	0 0 DADA-str 2!

: >DADA ( addr count )   DADA-str 2! ;

found? bell 0= [IF]   : bell ( -- )   7 emit ;				[THEN]

: DADA ( ... -- ... )		\ private debugging help
    bell cr ." DADA" cr
    base @ >r  decimal .s cr  r> base !
    DADA-do-1-xt @ EXECUTE	\ private debug scratch hook
    DADA-do-2-xt @ EXECUTE	\ private debug scratch hook
    DADA-do-3-xt @ EXECUTE	\ private debug scratch hook
    .world:step:spot		\ deferred

    DADA-str 2@ dup IF	\ display a label, if one is set by >DADA
	cr type
	0 0 DADA-str 2!	\ clear it
    ELSE 2drop THEN

    [ decimal ] 1024 allocate ABORT" DADA: Could not allocate." >r
    BEGIN
	cr
	r@ 1024 accept
	cr
    dup WHILE
	r@ swap EVALUATE
    REPEAT
    drop
    r> free ABORT" dada: Could not free." ;

[UNDEFINED] debugging [IF]
    VARIABLE debugging	debugging off	\ 'debug' as name is taken
[THEN]

VARIABLE halt		halt off

FALSE [IF]
    \ watch for a given step and stop, and set halt there:
    2variable (watch-spot)		-1. (watch-spot) 2!
    : watch-off ( -- )
	-1. (watch-spot) 2!
	s" ' noop IS <spot-do> " EVALUATE ;	\ just in case there is no [IS]

    : >watch-spot ( step spot )
	(watch-spot) 2!
	s" ' watch-spot IS <spot-do> " EVALUATE ;    \ in case there is no [IS]

    : watch-spot ( -- )  step @  spot @  (watch-spot) 2@  d= IF halt on THEN ;
[THEN]
