\ identity.fs
\ 	$Id: identity.fs,v 1.3 2009-10-12 05:40:47 f Exp $	

s" basics.fs"		REQUIRED
s" stringbuf-0.4.fs"	REQUIRED
s" file-tree.fs"	REQUIRED


\ Brew uses temorary files which could lead to problems if there is
\ more than one brew running. So I give each brew an identity which
\ is included in the file names.
VARIABLE (identity)

[UNDEFINED] define-program-identity
[IF]					\ does *not* work in vfx forth...
    : define-program-identity ( -- n )
	tmp-dir string!! >r
	program-name r@ cat
	s" -identity" r@ cat
	r>
	dup string@ ['] included CATCH IF  2drop -1 THEN
	1+
	dup (identity) !

	over string@ r/w CREATE-FILE IF
	    bell 2drop
	    cr ." Could not create file " over string@ type cr
	    2000 ms
	    99	\ dummy
	ELSE
	    over num>string third WRITE-LINE drop
	    CLOSE-FILE drop
	THEN
	swap stringbuf-close
    ;
[ELSE] \ workaround for vfx. See file 'vfx.fs'
    define-program-identity (identity) !    
[THEN]

: identity-string ( -- addr count )
    [ 16 stringbuf-open
    char _ over char-cat
    define-program-identity num>string  third cat   dup string@ ]
    sliteral
    [ stringbuf-close ] ;
