\ descriptors.fs

\ I often use data structures that refer to other data fields
\ I call them descriptors.
\ Descriptors store informations like
\	data count
\	pointer to allocated buffer
\	length of the allocated area
\
\	flags
\	...
\ the first three of them are predefined:
[IFUNDEF] OFFSET: INCLUDE basics.fs [THEN]
0
OFFSET: descriptor>count
OFFSET: descriptor>allocated
OFFSET: descriptor>length
CONSTANT desrcriptor-optional-offset#	\ start your offsets with this

\ descriptors are organised in fields.
\ each descriptor has a length of descriptor-size bytes.

\ the descriptor field is stored in a stringbuffer himself.
\ the default size gets dynamically increased if needed.

\ the descriptor field starts with
0
OFFSET: descriptor-descriptor-size	\ size of each descriptor in bytes
OFFSET: descriptor-field>max-items#	\ actual maximal descriptor count 
OFFSET: descriptor-field>last-handle	\ to cycle through handles
OFFSET: descriptor-field>addr		\ here the descriptors start
cell - CONSTANT field-descriptor-length#

