\ vfx.fs
\ $Id: vfx.fs,v 1.12 2009-10-28 09:52:28 f Exp $
\ Many thanks to Stephen Pelc for all the information needed.
\ ****************************************************************

\ This is work in progress, compiling but  *not working yet*


\ ****************************************************************
\ my personal vfx configuration
editor-is emacs
SetLocate --no-wait +%l% "%f%"

\ ****************************************************************
\ Activate floating point words:
\ include /usr/share/doc/VfxForth/Lib/Ndp387.fth
\ include /home/f/usr/share/doc/VfxForth/Lib/Ndp387.fth
include %vfxpath%/Lib/Ndp387.fth

\ ****************************************************************

: xt>string ( xt -- addr count )   >name count ;

[UNDEFINED] (>Shell) [IF]
    also system

    : (>Shell)	\ z$ -- ior
	\ *G Execute the given zero-terminated string as a shell command.
	PreSH ssystem PostSH ;

    previous
[THEN]

: <system> ( addr count -- error )
    dup 1+ allocate
    ABORT" <system>: Could not allocate."
    >r				( addr count  r: addr-allocated )
    swap r@ 2 pick move		( count       r: addr-allocated )
    r@ + 0 swap c!		( -- r: allocated)  \ zero terminated string
    r@ (>Shell)
    r> free ABORT" <system>: Could not free." ;


\ ****************************************************************
\ BUG  ########  see: identity.fs  ########

: define-program-identity ( -- n )
    [ ticks hex ffff decimal and ]
    literal ;

\ ****************************************************************
\ drop the data that vfxlin puts on the stack when called as follows:
\ vfxlin 'include brew.fs'
depth [IF]  drop  [THEN]


\ ****************************************************************
\ key mapping:
\ vfxlin KEY and EKEY do return decimal 10 on pressing <RETURN> in Linux...

[DEFINED] Target_386_Linux [IF]
    decimal 10 CONSTANT <return>	\ on Linux

    : key ( -- char )
	key dup CASE
	    <return> OF drop [ decimal ] 13 ENDOF
	ENDCASE ;

    \ [DEFINED] use-ekey [IF] \ must check this one too  ###################
    \ [THEN]

    [UNDEFINED] libc.so.6 [IF]	LIBRARY: libc.so.6  [THEN]	\ already there

    EXTERN: int opendir( const char * name );

    : string0 ( addr count -- addr2 ) \ zero terminated string
	pad >r >r
	2r@ move
	0 2r@ + c!
	2r> drop ;

    : open-dir ( c_addr u -- wdirid errorflag )   string0 opendir dup 0= ;

    EXTERN: int readdir( int * dirent );

    : read-dir ( buf maxlen wdirid -- u flag errorflag )
	readdir
	dup 0= IF drop 2drop 0 FALSE FALSE EXIT THEN
	11 +	\ horrible hack
	0
	BEGIN
	    2dup + c@ WHILE
	    1+
	REPEAT			( buf maxlen addr len )
	rot min >r		( buf addr   r: len' )
	swap r@ move		( --  r: len' )
	r> TRUE FALSE ;		( len true false )

    EXTERN:  int closedir( int * dirent );

    : close-dir ( wdirid -- flag )   closedir ;

[ELSE]
    [DEFINED] Target_386_Windows [IF]
	\ decimal 13 CONSTANT <return>	\ on DOS/Windows
    [ELSE]
	cr .( vfx FORTH running on unsupported OS )
	cr .( Please see file 'vfx.fs' )
	cr
    [THEN]
[THEN]

[DEFINED] open-dir CONSTANT use-fileselect

\ ****************************************************************
\ ['] / CATCH  bug:
\ On other FORTHs (but not on vfx) I can use the following:
\ : ?/ ( n n -- n|0 )   ['] / CATCH IF 2drop 0 THEN ;

DEFER log_div-error		' noop is log_div-error

\ Handmade version here, to work around this  ['] / CATCH  bug:
\ Not only division by zero, but also NANs can produce crashes.
\ This is what running brew told me. I don't know if there are
\ other critical combinations that should be included here.
\ I guess it could well be processor dependent.
: ?/ ( n n -- n )
    dup IF		\ check for division by zero
	over		\ now check for NAN
	\ [ decimal ] 2147483648 \ decimal representation of 32bit NAN 
	[ 1  1 cells 8 * 1 -  lshift ] literal = IF		\ NAN 32/64bit
	    dup -1 = IF			\ this combination crashes!
		log_div-error
		2drop 0			\ meaningless result...
		EXIT
	    THEN
	THEN
	/
    ELSE
	log_div-error
	2drop 0				\ meaningless result...
    THEN ;

\ ****************************************************************

[UNDEFINED] flnp1 [IF] \ Thanks to Stephen Pelc.
    code flnp1	\ F: f1 -- f2
	\ *G The output *\i{f2} is the natural logarithm of the input
	\ ** plus one. An ambiguous condition exists if *\i{f1} is less 
	\ **than or equal to negative one.
	fld1
	faddp st(1), st
	fldln2
	fxch
	fyl2x
	ret
    end-code
[THEN]
